freeslot("sfx_fadjmp")

addHook("ThinkFrame", do
	for p in players.iterate
		if p and p.mo
			if p.frankbt == nil
				p.frankbt = BT_CUSTOM2
				p.frankbttxt = "2"
			end
		end
	end
end)

COM_AddCommand("frankjumpbutton", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "custom1"
			player.frankbt = BT_CUSTOM1
			player.frankbttxt = "1"
			CONS_Printf(player, "Jump button set to Custom 1!")
		elseif arg == "custom2"
			player.frankbt = BT_CUSTOM2
			player.frankbttxt = "2"
			CONS_Printf(player, "Jump button set to Custom 2!")
		elseif arg == "custom3"
			player.frankbt = BT_CUSTOM3
			player.frankbttxt = "3"
			CONS_Printf(player, "Jump button set to Custom 3!")
		end
	else
		CONS_Printf(player, "frankjumpbutton [custom1/custom2/custom3] - Switch which button to press to jump as Frank! Default: Custom 2")
	end
end)

local jumpdust = function(inflictor, ns, item)
	local i = 0
	while i < 15
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, item)
		mo.scale = inflictor.scale
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa), ns)
			mo.momx = FixedMul(sin(fa), ns)
		end
		i = $+1
	end
end
//Frank's Jump
addHook("ThinkFrame", do
	for p in players.iterate
		if p and p.mo
			if (p.mo.skin == "frank") and (p.playerstate == PST_LIVE)
				//variables
				if p.favjumped == nil
				or (P_IsObjectOnGround(p.mo))
					p.favjumped = 0 
				end
				
				if p.jumpdelay == nil
					p.jumpdelay = 0
					p.jumptimer = 0
					p.driftvar = 0
				end
				
				//delayer
				if p.jumpdelay == 1
					p.jumptimer = $ + 1
					if p.jumptimer == 50
						p.jumpdelay = 0
						p.jumptimer = 0
						S_StartSound(p.mo, sfx_tink, p)
					end
				end
				
				if p.favhold == nil
				or not (p.cmd.buttons & (p.frankbt))
					p.favhold = 0
				end
				
				//the jump part
				if (p.cmd.buttons & (p.frankbt))
				and p.favjumped == 0
				and (P_IsObjectOnGround(p.mo))
				and p.favhold == 0
				and p.jumpdelay == 0
				and p.driftvar == 0
					if p.mo.eflags & MFE_UNDERWATER
						jumpdust(p.mo, 7 << FRACBITS, MT_SMALLBUBBLE)
					else
						jumpdust(p.mo, 7 << FRACBITS, MT_DRIFTDUST)
					end
					P_SetObjectMomZ(p.mo, 8*FRACUNIT, true)
					if p.mo.eflags & MFE_UNDERWATER
						p.mo.momz = $*3/5
					end
					S_StartSound(p.mo, sfx_fadjmp)
					p.pflags = $|PF_JUMPED
					p.favjumped = 1
					p.favhold = 1
					p.jumpdelay = 1
					//delete sparks to prevent rainbow drifting in a line
					if p.kartstuff[k_drift] != 0
						if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p) //blue
						and p.kartstuff[k_driftcharge] < K_GetKartDriftSparkValue(p)*2
							p.kartstuff[k_driftcharge] = 0 //nada
						end
						if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*2 //red
						and p.kartstuff[k_driftcharge] < K_GetKartDriftSparkValue(p)*4
							p.kartstuff[k_driftcharge] = 900 //back to blue
						end
						if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*4 //rainbow
							p.kartstuff[k_driftcharge] = 1900 //back to red
						end
					end
				end
				if not (p.cmd.buttons & BT_DRIFT)
				and not (P_IsObjectOnGround(p.mo))
				and p.favjumped == 1
					p.kartstuff[k_driftcharge] = 0
				end
			end
		end
	end
end)

//Sproing
addHook("ThinkFrame", do
	for p in players.iterate
		if p and p.mo
			if (p.mo.skin == "frank" or p.mo.skin == "dummie") and (p.playerstate == PST_LIVE)
				if (p.kartstuff[k_pogospring])
				and not (p.health < 1)
				and not (p.mo.frame == Q)
				or (p.hastricked)
				and not (p.health < 1)
					p.mo.frame = T
				end
			end
		end
	end
end)
//Frank Gui
local function drawFrankJump(d, p, cam)
	if (p.mo and p.mo.valid and p.mo.skin != "frank") return end
	if p.mo and p.mo.valid
		if (p.mo.skin == "frank")
			if p.jumpdelay == 1
				d.draw(200, 110, d.cachePatch("RDJUMP"), V_SNAPTOBOTTOM)
			else
				d.draw(200, 110, d.cachePatch("GRJUMP"), V_SNAPTOBOTTOM)
			end
		end
	end
	//text
	if leveltime <= 200
	and ((cam.pnum == 1) or not splitscreen)
	and (p.mo and p.mo.valid and p.mo.skin == "frank")
		d.drawString(160, 50, "Press Custom " + p.frankbttxt + " to jump!", V_SNAPTOTOP|V_ALLOWLOWERCASE|V_YELLOWMAP, "center")
	end
	if leveltime >= 201 and leveltime < 203
	and ((cam.pnum == 1) or not splitscreen)
	and (p.mo and p.mo.valid and p.mo.skin == "frank")
		d.drawString(160, 50, "Press Custom " + p.frankbttxt + " to jump!", V_SNAPTOTOP|V_ALLOWLOWERCASE|V_YELLOWMAP|V_40TRANS, "center")
	end
	if leveltime > 203 and leveltime < 206
	and ((cam.pnum == 1) or not splitscreen)
	and (p.mo and p.mo.valid and p.mo.skin == "frank")
		d.drawString(160, 50, "Press Custom " + p.frankbttxt + " to jump!", V_SNAPTOTOP|V_ALLOWLOWERCASE|V_YELLOWMAP|V_80TRANS, "center")
	end
end
hud.add(drawFrankJump, "game")